include(FetchContent)

macro(Exo_MakeAvailable)
  cmake_parse_arguments(ARG "EXCLUDE_FROM_ALL" "" "" ${ARGN})
  foreach(contentName IN ITEMS ${ARG_UNPARSED_ARGUMENTS})
    string(TOLOWER ${contentName} contentNameLower)
    FetchContent_GetProperties(${contentName})
    if(NOT ${contentNameLower}_POPULATED)
      FetchContent_Populate(${contentName})

      if(EXISTS ${${contentNameLower}_SOURCE_DIR}/CMakeLists.txt)
        if(ARG_EXCLUDE_FROM_ALL)
          add_subdirectory(${${contentNameLower}_SOURCE_DIR} ${${contentNameLower}_BINARY_DIR} EXCLUDE_FROM_ALL)
        else()
          add_subdirectory(${${contentNameLower}_SOURCE_DIR} ${${contentNameLower}_BINARY_DIR})
        endif()
      endif()
    endif()
  endforeach()
endmacro()
